uses
   Objects, DOS;

var
   f1, f2          :TBufStream;
   n1, n2          :PathStr;
   Dir             :DirStr;
   Name            :NameStr;
   Ext             :ExtStr;

const
   Buf =           $4000;

type
   TSoundHeader=
   record
      IdRIFF       :Array [1..4] of Char;
      FileSize     :LongInt;
      IdWAVEfmt    :Array [1..8] of Char;
      Unknown1     :LongInt;
      Unknown2     :LongInt;
      Frequency1   :LongInt;
      Frequency2   :LongInt;
      Unknown3     :LongInt;
      IdData       :Array [1..4] of Char;
      DataSize     :LongInt;
   end;

const
   Header          :TSoundHeader=
   (idRIFF:'RIFF'; FileSize:0; IdWAVEfmt:'WAVEfmt ';
    Unknown1:$10; Unknown2:$10001; Frequency1:0; Frequency2:0;
    Unknown3:$80001; IdData:'data'; DataSize:0);

begin
   WriteLn('Scream Tracker Samples -> Windows Sound File (.WAV) Converter');
   WriteLn('Copyright (c) 1994 by Sasha Peslyak'#13#10);
   if ParamCount<1 then
   begin
      WriteLn('Usage : MAKEWAVE.EXE filename.ext'); Halt;
   end;
   n1:=ParamStr(1);
   FSplit(n1, Dir, Name, Ext);
   n2:=Dir+Name+'.WAV';

   Write('Frequency : '); ReadLn(Header.Frequency1);
   Header.Frequency2:=Header.Frequency1;

   f1.Init(n1, stOpenRead, Buf); f2.Init(n2, stCreate, Buf);
   Header.FileSize:=f1.GetSize+SizeOf(Header); Header.DataSize:=f1.GetSize+4;
   f2.Write(Header, SizeOf(Header));
   f2.CopyFrom(f1, f1.GetSize);
   if (f1.Status<>stOk) or (f2.Status<>stOk) then WriteLn('An error occured');
   f2.Done; f1.Done;
end.
